/*jsl:declare module*/
/*jsl:declare console*/
var path = require("path");
var domTest = require("justtest").domTestCase;

module.exports = domTest({

  scripts: ["require.js"],
  scriptPath: "tests/include",

  setUp: function(callback) {
    this.globals.window.require.config({
      waitSeconds: 1
    });
    var oldDefine = this.globals.window.define;
    this.globals.window.define = function(paths, dcallback) {
      console.log(arguments);
      if (typeof dcallback === "undefined") {
        console.log("No requirements!");
        return oldDefine(paths);
      }
      paths = paths.map(function(requirePath) {
        return path.join(process.cwd()+"/tests/include", requirePath);
      });
      return oldDefine(paths, dcallback);
    };
    var self = this;
    console.log(self);
    this.globals.window.require(["../tests/include/awesome_lib.js"], function(Awesome) {
      self.globals.Awesome = Awesome;
      callback();
    });
  },

  testOk: function(test) {
    console.log(this);
    test.equals(this.globals.Awesome.foo, "bar");
    test.equals(this.globals.Awesome.depends, "baz");
    test.done();
  }

});
